function thmitoolbar_refresh()
{
	thmitoolbar_update_labels("ask");
	thmitoolbar_update_labels("bid");
}

function thmitoolbar_update_labels(pt /* price type */) {
	
	var s /* system */ = document.getElementById("thmitoolbar-systems").selectedItem.value;

	var xhr = new XMLHttpRequest();
	xhr.open('GET', 'http://eve-factory.com/thmi/thmi-api.php?pricetype=' + pt + '&' +  s);

	xhr.onreadystatechange = function () {  
		if (xhr.readyState == 4 && xhr.status == 200) {
			var mes /* mineral elements */ = xhr.responseXML.documentElement.getElementsByTagName("mineral");
			for ( mi /* mineral index */ in mes ) {
				var me /* mineral element */ = mes[mi];
		               	var mn /* mineral name */ = me.getAttribute("mineral_name").toLowerCase();
				var lid /* label id */ = "thmitoolbar-" + mn + "-price-" + pt;
				var l /* label */ = document.getElementById(lid);
				l.value = me.getAttribute("price");
				l.setAttribute("tooltiptext", 
					"Volume at price: " + me.getAttribute("volume_at_price") + 
					"\nTotal volume: "  + me.getAttribute("total_volume") +
					"\nReported at: "   + me.getAttribute("reported_at")
				);
			}
		}
	}
	xhr.send(null);
}

function thmitoolbar_system_changed() {
	var p = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	p.setIntPref("extensions.thmitoolbar.systemIndex", document.getElementById("thmitoolbar-systems").selectedIndex);
	thmitoolbar_refresh();
}

window.addEventListener("load", function() {
	var p = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	document.getElementById("thmitoolbar-systems").selectedIndex = p.getIntPref("extensions.thmitoolbar.systemIndex");
	window.setInterval(thmitoolbar_refresh, p.getIntPref("extensions.thmitoolbar.updateInterval"));
	thmitoolbar_refresh();
}, false);